#include <math.h>
#include "mex.h"
#define _EPS_CVG   0.0005

/* function [Lu] = updatechol(L,index, AddToA, type)*/


void mexFunction( int nlhs, mxArray *plhs[],  int nrhs, const mxArray *prhs[])
{
  
  int  n, i, j, k;
  double sumligne;
  int index, type;
  
     
  /* Check for proper number of input and output arguments */    
  if (nrhs != 4 ) {
    mexErrMsgTxt("Wrong number of input arguments.");
  } 
 
  if(nlhs > 1){
    mexErrMsgTxt("Too many output arguments.");
  }


  /* VERIFICATION DE COMPATIBILITE */
    
  n           = mxGetM(prhs[0]); /* matrice carree*/
  index       = *mxGetPr(prhs[1]);  
  type        = *mxGetPr(prhs[3]); /* +1 ou -1*/
  /* mexPrintf("n %d index %d type %d\n", n,index,type);*/
 

  if(type ==1) {

    plhs[0]=mxCreateDoubleMatrix(n+1,n+1,mxREAL); /* Lu avec les zeros par defaut */
    
     for(i=0; i<index; i++)
      for(j=0; j<i+1; j++) /* modif accel*/
	mxGetPr(plhs[0])[j*(n+1)+i] = mxGetPr(prhs[0])[j*(n)+i];

    for(i=index+1; i<n+1; i++)
      for(j=0;j<index;j++)
	mxGetPr(plhs[0])[j*(n+1)+i] = mxGetPr(prhs[0])[j*(n)+(i-1)];

   for(i=index+1; i<n+1; i++)
      for(j=index+1; j<i+1; j++) /* modif accel*/
	mxGetPr(plhs[0])[j*(n+1)+i] = mxGetPr(prhs[0])[(j-1)*(n)+(i-1)];

    

    /* description de la index^e ligne de L*/
  
    for(j=0; j<index; j++) {
      sumligne = 0.;
      for (k=0; k<j; k++) 
	sumligne  = sumligne + (mxGetPr(plhs[0])[k*(n+1)+(index)]*mxGetPr(plhs[0])[k*(n+1)+(j)]); 
      mxGetPr(plhs[0])[j*(n+1)+(index)] =  (mxGetPr(prhs[2])[j] - sumligne)/mxGetPr(plhs[0])[j*(n+1)+(j)];
    }

    /* terme diag*/
    sumligne = 0.;
    for (k=0; k<index; k++) 
      sumligne  = sumligne + (mxGetPr(plhs[0])[k*(n+1)+(index)]*mxGetPr(plhs[0])[k*(n+1)+(index)]);
	
    mxGetPr(plhs[0])[(index)*(n+1)+(index)] = sqrt(mxGetPr(prhs[2])[index] - sumligne);
     j = index;
    for(i=index+1; i<n+1; i++) {
      sumligne = 0;
      for (k=0; k<j; k++)
	sumligne  = sumligne + (mxGetPr(plhs[0])[k*(n+1)+(i)]*mxGetPr(plhs[0])[k*(n+1)+(j)]);
      
      mxGetPr(plhs[0])[(j)*(n+1)+(i)] = (mxGetPr(prhs[2])[i] - sumligne)/mxGetPr(plhs[0])[j*(n+1)+(j)];
	 }
  }
  else if (type==-1) {
  
     plhs[0]=mxCreateDoubleMatrix(n-1,n-1,mxREAL); /* Lu*/
    
    for(i=0; i<index-1; i++)
      for(j=0; j<i+1; j++) /* modif accel*/
	mxGetPr(plhs[0])[j*(n-1)+i] = mxGetPr(prhs[0])[j*(n)+i];


    for(i=index-1; i<n-1; i++)
      for(j=0; j<index-1; j++)
	mxGetPr(plhs[0])[j*(n-1)+i] = mxGetPr(prhs[0])[j*(n)+(i+1)];

    for(i=index-1; i<n-1; i++)
      for(j=index-1; j<i+1; j++)/* modif accel*/
	mxGetPr(plhs[0])[j*(n-1)+i] = mxGetPr(prhs[0])[(j+1)*(n)+(i+1)];
   } 
else
    mexErrMsgTxt("Impossible update !!");


}
