function checkers_multiclass(method)
close all;
global svModel;
%--------------------------------------------------
n='multiclasscheckers';
[x,y,xt,yt,xtt,ytt] = dataset(n,500,50,0.5);
donnees = data(x,y,xt,yt);
clear x;
clear y;
clear xt;
clear yt;
clear xtt;
clear ytt;
multiclass = '1vsall';

%-----------------------------------------------------
%   Learning Parameters
C = 100;
p = [5];
ker= 'rbf';
tolerance = 1e-5;
pas = 20;
% meth = 'qr';
parametres = param(C,pas,multiclass,method,tolerance);
noyau = kernel(ker,p);

%-----------------------------------------------------
% Learning and testing 1vs1
trainSVM(donnees,noyau,parametres);
prediction = testSVM;
% perf = length(find(donnees.testlab==prediction(:,1)))/length(prediction);
perf = length(find(donnees.testlab==prediction))/length(prediction);
fprintf(1,'performance en test: %2.2f \n',100*perf);

%--------------Testing Generalization performance ---------------
[xtesta1,xtesta2]=meshgrid([-4:0.1:4],[-4:0.1:4]);
[na,nb]=size(xtesta1);
xtest1=reshape(xtesta1,1,na*nb);
xtest2=reshape(xtesta2,1,na*nb);
xtest=[xtest1;xtest2]';
svModel.data.testvec = xtest';
[ypred] = testSVM;
ypredmat=reshape(ypred(:,1),na,nb);
%----------------------Plotting---------------------------------

contourf(xtesta1,xtesta2,ypredmat,50);shading flat;
hold on
[cs,h]=contour(xtesta1,xtesta2,ypredmat,[-1 0 1],'k');
%clabel(cs,h);
h1=plot(donnees.trainvec(1,donnees.trainlab==1),donnees.trainvec(2,donnees.trainlab==1),'+k'); 
%set(h1,'LineWidth',2);

h2=plot(donnees.trainvec(1,donnees.trainlab==2),donnees.trainvec(2,donnees.trainlab==2),'xk'); 
h3=plot(donnees.trainvec(1,donnees.trainlab==3),donnees.trainvec(2,donnees.trainlab==3),'*k'); 
h4=plot(donnees.trainvec(1,donnees.trainlab==4),donnees.trainvec(2,donnees.trainlab==4),'vk'); 
%set(h2,'LineWidth',2);
h5=plot(donnees.trainvec(1,svModel.model.indices{1}),donnees.trainvec(2,svModel.model.indices{1}),'ok'); 
set(h5,'LineWidth',2);



xlabel('x1');ylabel('x2');
title('Learning Data and Margin ');
axis([-2 2 -2 2]);

