clear all;
close all;
load data_epo.mat;
%rn = randperm(length(y));
%x = x(:,rn);
%y = y(rn);
multiclass='';
global svModel;

%-----------------------------------------------------
%   Learning Parameters
C = 500;
p = [3];
tolerance = 1e-8;
pas = 10;
meth = 'qr';
parametres = param(C,pas,multiclass,meth,tolerance);
i = 1;
tailles = [300,500,800,1000,1300,1500,2000,2300,2500,3000,3300,3500,3800,4000,4500];
for taille = tailles
	
	% Dataset
	donnees = data(x(:,1:taille),y(1:taille));
	t1 = cputime;
	% Gaussian kernel
	ker= 'rbf';
	noyau = kernel(ker,p);
	trainSVM(donnees,noyau,parametres);
	tGauss(i) = cputime - t1;

	i = i+1;
end


clear global svModel;
i = 1;

for taille = tailles
	
	% Dataset
	donnees = data(x(:,1:taille),y(1:taille));
	t1 = cputime;
	% Epanech kernel
	ker= 'epanech';
	noyau = kernel(ker,p);
	trainSVM(donnees,noyau,parametres);
	tEpa(i) = cputime - t1;

	i = i+1;
end

%  tAkoa = [7.55,6.259,4.947,8.672,6.96,17.425,27.809,34.129,163.265,321.191,297.45]; % C=100
% tAkoa = [5.2, 4.9, 5.6, 6.5, 7.6, 7.7, 32, 83, 144, 364, 782]; % C=500
tAkoaEpo = [1.41,2.70,6.03,5.61,6.42,22.74,26.13,39.60,59.84,62.00,65.4,102.58,103.33,137.71,269.42];
tAkoaRbf = [1.91,10.97,31.83,48.05,58.40,113.70,188.34,371.70,570.60,671.19,695.67,771.68,1515.77,1655.12,2144.72];

figure;
subplot(2,1,1);
hold on;
plot(log(tailles),log(tGauss),'r-+');
plot(log(tailles),log(tEpa),'b-.o');
plot(log(tailles),log(tAkoaEpo),'g--s');
plot(log(tailles),log(tAkoaRbf),'m:*');
legend('rbf-kernel simpleSVM','epanech-kernel simpleSVM','points intrieurs epanech', 'points interieurs rbf');
title('Log-Log');
xlabel('log size');
ylabel('log time');
hold off;

subplot(2,1,2);
hold on;
plot((tailles),(tGauss),'r-+');
plot((tailles),(tEpa),'b-.o');
plot((tailles),(tAkoaEpo),'g--s');
plot((tailles),(tAkoaRbf),'m:*');
legend('rbf-kernel simpleSVM','epanech-kernel simpleSVM','points intrieurs epanech', 'points interieurs rbf');
title('Time depending on size of the dataset');
xlabel('size');
ylabel('time');
hold off;

%  figure;
%  hold on;
%  [xtesta1,xtesta2]=meshgrid([-2.1:0.05:2.1],[-2.1:0.05:2.1]);
%  [na,nb]=size(xtesta1);
%  xtest1=reshape(xtesta1,1,na*nb);
%  xtest2=reshape(xtesta2,1,na*nb);
%  xtest=[xtest1;xtest2];
%  svModel.data.testvec = xtest;
%  ypred = testSVM;
%  %[ypred,maxi]=OnLineSVM_1vs_all_val(d,alpha,pos,nbsv,b,yapp,xtest',xapp);
%  ypredmat=reshape(ypred,na,nb);
%  contourf(xtesta1,xtesta2,ypredmat,30);shading flat
%  hold on
%  [cs,h]=contour(xtesta1,xtesta2,ypredmat,[-1 1],'k');
%  clabel(cs,h);
%  plot(donnees.trainvec(1,find(donnees.trainlab==1)),donnees.trainvec(2,find(donnees.trainlab==1)),'rx');
%  plot(donnees.trainvec(1,find(donnees.trainlab==-1)),donnees.trainvec(2,find(donnees.trainlab==-1)),'bx');
%  hold off;


