%
%  SVM Classification 2D examples
%
%

%function [t] =  exclass(method) 
method = 'chol'
%close all
global svModel;

%rand('state',0)
%randn('state',0)

%-------------Data Set-------------------------------------
nbapp=300;
nbtest=20;
sigma=.4;
[vector_training_set,label_training_set,vector_test_set,label_test_set]=dataset('checkers',nbapp,nbtest,sigma);
rn = randperm(length(label_training_set))';
donnees = data(vector_training_set(:,rn),label_training_set(rn),vector_test_set,label_test_set);
%-----------------------------------------------------
%   Learning and Learning Parameters
% meth = 'qr';
multiclass = '';
C = 100;
tolerance = 0.00001;
noyau = kernel('rbf',[1]);
pas = 100;
parametres = param(C,pas,multiclass,method,tolerance);
%parametres.type = 'nu';
%parametres.epoch = 3;
%parametres.shrinkdelay = 10;
tic
trainSVM(donnees, noyau, parametres);
t = toc
%--------------Testing Generalization performance ---------------
[xtesta1,xtesta2]=meshgrid([-2:0.1:2],[-2:0.1:2]);
[na,nb]=size(xtesta1);
xtest1=reshape(xtesta1,1,na*nb);
xtest2=reshape(xtesta2,1,na*nb);
xtest=[xtest1;xtest2]';
svModel.data.testvec = xtest';
[ypred] = testSVM;
ypredmat=reshape(ypred(:,1),na,nb);
%----------------------Plotting---------------------------------

ind1=find(ypred>0);
indm1=find(ypred<0);

figure
colormap('gray');
contourf(xtesta1,xtesta2,ypredmat,50);shading flat;
hold on
[cs,h]=contour(xtesta1,xtesta2,ypredmat,[-1 0 1],'r');
clabel(cs,h);
h1=plot(svModel.data.trainvec(1,svModel.data.trainlab==1),svModel.data.trainvec(2,svModel.data.trainlab==1),'+g'); 
set(h1,'LineWidth',2);

h2=plot(svModel.data.trainvec(1,svModel.data.trainlab==-1),svModel.data.trainvec(2,svModel.data.trainlab==-1),'xb'); 
set(h2,'LineWidth',2);
h3=plot(svModel.data.trainvec(1,svModel.model.indices{1}),svModel.data.trainvec(2,svModel.model.indices{1}),'oy'); 
set(h3,'LineWidth',2);



xlabel('x1');ylabel('x2');
title('Learning Data and Margin ');
axis([-2 2 -2 2]);
%clear global svModel;
