%
%   SVM 2D Classification 
%   Comparing Gaussian and polynomial Kernels 
%
%
function exclass2(method)

close all
global svModel;
%
%   Creating Data
%

x=0:0.01:4;
f = 0.95*cos(0.5*(exp(x)-1));
nbapp=100;
nn=20;
nbtest=nn*nn;
[vector_training_set,label_training_set,vector_test_set,label_test_set,xtest1,xtest2]=dataset('CosExp',nbapp,nbtest);
donnees = data(vector_training_set,label_training_set,vector_test_set,label_test_set);

%
%  learning with polynomial kernels
%

tolerance = 1e-5;  
multiclass = '';
C = 1000;
noyau = kernel('poly',[4,.3]);
pas = 5;
%meth = 'qr';
parametres = param(C,pas,multiclass,method,tolerance);
trainSVM(donnees, noyau, parametres);
ypred = testSVM;
ypred = reshape(ypred(:,1),nn,nn); 



%
%               plotting
%

figure(1); 
clf; 
contourf(xtest1,xtest2,ypred,50);shading flat;
hold on
h = plot(x,f,'m'); 
set(h,'LineWidth',2);
h1=plot(vector_training_set(1,label_training_set==1),vector_training_set(2,label_training_set==1),'+k'); 
h2=plot(vector_training_set(1,label_training_set==-1),vector_training_set(2,label_training_set==-1),'xk'); 
h3=plot(vector_training_set(1,svModel.model.indices{1}),vector_training_set(2,svModel.model.indices{1}),'ok'); 
set(h1,'LineWidth',2);
set(h2,'LineWidth',2);
set(h3,'LineWidth',2);
[cc, hh]=contour(xtest1,xtest2,ypred,[-100000,-1 0 1],'k-'); 
clabel(cc,hh); 
hold off
title('Classifying CosExp with polynomial kernel');

%-------------------  Gaussian Kernel -------------------------

noyau = kernel('rbf',1);
trainSVM(donnees, noyau, parametres);
ypred = testSVM;
ypred = reshape(ypred,nn,nn); 

%
%               plotting
%
 
figure(2); 
clf;
contourf(xtest1,xtest2,ypred,50);shading flat;
hold on
h = plot(x,f,'m'); 
set(h,'LineWidth',2);
h1=plot(vector_training_set(1,label_training_set==1),vector_training_set(2,label_training_set==1),'+k'); 
h2=plot(vector_training_set(1,label_training_set==-1),vector_training_set(2,label_training_set==-1),'xk'); 
h3=plot(vector_training_set(1,svModel.model.indices{1}),vector_training_set(2,svModel.model.indices{1}),'ok'); 
set(h1,'LineWidth',2);
set(h2,'LineWidth',2);
set(h3,'LineWidth',2);
[cc, hh]=contour(xtest1,xtest2,ypred,[-100000,-1 0 1],'k'); 
title('Classifying CosExp with gaussian kernel');
clabel(cc,hh); 
hold off
clear global svModel;