%
%
%   Example of Semiparametric Classificition
%
%
%


close all
global label_training_set;
global vector_training_set;
global label_test_set;
global vector_test_set;
global meth;

x=0:0.01:4;
f = 0.95*cos(0.5*(exp(x)-1));
nbapp=100;
nn=20;
nbtest=nn*nn;
[vector_training_set,label_training_set,vector_test_set,label_test_set,xtest1,xtest2]=dataset('CosExp',nbapp,nbtest);

%
%  learning with polynomial kernels
%

tolerance = 1e-7;  
C = 100;
d = svm_kernel('poly',[2,1]);
b = 0;
pas = 50;
active = [1;nbapp];
phi = phispan(vector_training_set,'sin2D');
phitest = phispan(vector_test_set,'sin2D');
[alpha,pos,nbsv,b] = OnLineSVM_main(d,C,meth,pas,tolerance,active,phi');
[ypred] = OnLineSVM_val(d,alpha,pos,nbsv,b,phitest');
ypred = reshape(ypred,nn,nn); 


%
%               plotting
%

figure(1); 
clf; 
contourf(xtest1,xtest2,ypred,50);shading flat;
hold on
h = plot(x,f,'m'); 
set(h,'LineWidth',2);
h1=plot(vector_training_set(1,label_training_set==1),vector_training_set(2,label_training_set==1),'+k'); 
h2=plot(vector_training_set(1,label_training_set==-1),vector_training_set(2,label_training_set==-1),'xk'); 
h3=plot(vector_training_set(1,pos),vector_training_set(2,pos),'ok'); 
set(h1,'LineWidth',2);
set(h2,'LineWidth',2);
set(h3,'LineWidth',2);
[cc, hh]=contour(xtest1,xtest2,ypred,[-100000,-1 0 1],'k-'); 

clabel(cc,hh); 
hold off