%
%  SVM Classification 2D examples
%
%  15/06/00 AR

function exclassCdiff(method) 
close all
global svModel;

%-------------Data Set-------------------------------------
n = 50; 
sigma=0.5;
[vector_training_set,label_training_set,vector_test_set,label_test_set]=dataset('gaussian',n,10,sigma);
donnees = data(vector_training_set,label_training_set,vector_test_set,label_test_set);
%-----------------------------------------------------
%   Learning and Learning Parameters
Cpos=1000; %  assymetric C 
Cneg=inf;
C=Cpos*(label_training_set==1)+Cneg*(label_training_set==-1);
meth = 'qr';
multiclass = '';
tolerance = .00001;
noyau = kernel('rbf',1);
pas = 50;
parametres = param(C,pas,multiclass,meth,tolerance);
trainSVM(donnees, noyau, parametres);
%--------------Testing Generalization performance ---------------
[xtest1 xtest2]  = meshgrid([-1:.05:1]*3.5,[-1:0.05:1]*3); 
nn = length(xtest1); 
xtest = [reshape(xtest1 ,nn*nn,1) reshape(xtest2 ,nn*nn,1)]; 
svModel.data.testvec = xtest';
[ypred] = testSVM;
ypred=reshape(ypred(:,1),nn,nn);
%----------------------Plotting---------------------------------

ind1=find(ypred>0);
indm1=find(ypred<0);

contourf(xtest1,xtest2,ypred,50);shading flat;
hold on
[cs,h]=contour(xtest1,xtest2,ypred,[-1 0 1],'k');
clabel(cs,h);
h1=plot(vector_training_set(1,label_training_set==1),vector_training_set(2,label_training_set==1),'+k'); 
set(h1,'LineWidth',2);

h2=plot(vector_training_set(1,label_training_set==-1),vector_training_set(2,label_training_set==-1),'xk'); 
set(h2,'LineWidth',2);
h3=plot(vector_training_set(1,svModel.model.indices{1}),vector_training_set(2,svModel.model.indices{1}),'ok'); 
set(h3,'LineWidth',2);



xlabel('x1');ylabel('x2');
title('Learning Data and Margin ');
axis([-2 2 -2 2]);
clear global svModel;
