clear all
tic;
global svModel;
figure;

%-------------Data Set-------------------------------------
nbapp=10000;
nbtest=10;
sigma=0.2;
%randn('state',0);
%rand('state',0);
[vector_training_set,label_training_set,vector_test_set,label_test_set]=dataset('checkers',nbapp,nbtest,sigma);
rn = randperm(length(label_training_set));
vector_training_set = vector_training_set(:,rn);
label_training_set = label_training_set(rn);
donnees = data(vector_training_set,label_training_set,vector_test_set,label_test_set);
%-----------------------------------------------------
%   Learning and Learning Parameters
method = 'chol';
multiclass = '';
C = 1000000;
tolerance = 10^-7;
noyau = kernel('rbf',1);
pas = 100;
%pas = 1;
parametres = param(C,pas,multiclass,method,tolerance);
%parametres.type = 'lasvm';
%parametres.epoch = 1;
trainSVM(donnees, noyau, parametres);
%--------------Testing Generalization performance ---------------
[xtesta1,xtesta2]=meshgrid([-4:0.1:4],[-4:0.1:4]);
[na,nb]=size(xtesta1);
xtest1=reshape(xtesta1,1,na*nb);
xtest2=reshape(xtesta2,1,na*nb);
xtest=[xtest1;xtest2]';
svModel.data.testvec = xtest';
[ypred] = testSVM;
ypredmat=reshape(ypred(:,1),na,nb);
%----------------------Plotting---------------------------------

ind1=find(ypred>0);
indm1=find(ypred<0);

contourf(xtesta1,xtesta2,ypredmat,50);shading flat;
colormap('gray');
hold on
h1=plot(vector_training_set(1,label_training_set==1),vector_training_set(2,label_training_set==1),'+r'); 
set(h1,'LineWidth',2);

h2=plot(vector_training_set(1,label_training_set==-1),vector_training_set(2,label_training_set==-1),'xb'); 
set(h2,'LineWidth',2);
h3=plot(vector_training_set(1,svModel.model.indices{1}),vector_training_set(2,svModel.model.indices{1}),'oy'); 
set(h3,'LineWidth',2);
[cs,h]=contour(xtesta1,xtesta2,ypredmat,[-1 0 1],'k');
clabel(cs,h);



xlabel('x1');ylabel('x2');
title('Learning Data and Margin ');
axis([-2 2 -2 2]);
clear global svModel;
toc