
%function exclass_weighs
clear all
close all
global svModel;

%-------------Data Set-------------------------------------
nbapp=50;
nbtest=10;
sigma=0.2;
[vector_training_set1,label_training_set1,vector_test_set1,label_test_set1]=dataset('Gaussian',nbapp,nbtest,sigma);
[vector_training_set2,label_training_set2,vector_test_set2,label_test_set2]=dataset('Gaussian',nbapp,nbtest,sigma);

vector_training_set = [vector_training_set1, vector_training_set2 + kron([2;1],ones(1, nbapp))];
label_training_set = [label_training_set1;label_training_set2];
vector_test_set = [vector_test_set1, vector_test_set2 + kron([2;1],ones(1, nbtest))];
label_test_set = [label_test_set1;label_test_set2];

rn = randperm(2*nbapp);



donnees = data(vector_training_set(:,rn),label_training_set(rn),vector_test_set,label_test_set);
%-----------------------------------------------------
%   Learning and Learning Parameters
method = 'chol';
multiclass = '';
C = 100;
tolerance = .0001;
% noyau = kernel('rbf',.9);
noyau = kernel('poly',[1 1]);
pas = 10;
parametres = param(C,pas,multiclass,method,tolerance);
%parametres.weighs = ones(length(label_training_set),1); %% this is where you put your weighs instead of the rand!
parametres.weighs = [.1*ones(nbapp,1);10*ones(nbapp,1)]; %% this is where you put your weighs instead of the rand!
parametres.weighs = parametres.weighs(rn);
%0.2*rand(length(label_training_set),1)+
trainSVM(donnees, noyau, parametres);
%--------------Testing Generalization performance ---------------
[xtesta1,xtesta2]=meshgrid([-4:0.1:4],[-4:0.1:4]);
[na,nb]=size(xtesta1);
xtest1=reshape(xtesta1,1,na*nb);
xtest2=reshape(xtesta2,1,na*nb);
xtest=[xtest1;xtest2]';
svModel.data.testvec = xtest';
[ypred] = testSVM;
ypredmat=reshape(ypred(:,1),na,nb);
%----------------------Plotting---------------------------------

ind1=find(ypred>0);
indm1=find(ypred<0);

contourf(xtesta1,xtesta2,ypredmat,50);shading flat;
hold on
[cs,h]=contour(xtesta1,xtesta2,ypredmat,[-1 0 1],'k');
clabel(cs,h);
h1=plot(vector_training_set(1,label_training_set==1),vector_training_set(2,label_training_set==1),'+k'); 
set(h1,'LineWidth',2);

h2=plot(vector_training_set(1,label_training_set==-1),vector_training_set(2,label_training_set==-1),'xk'); 
set(h2,'LineWidth',2);
h3=plot(vector_training_set(1,svModel.model.indices{1}),vector_training_set(2,svModel.model.indices{1}),'ok'); 
set(h3,'LineWidth',2);



xlabel('x1');ylabel('x2');
title('Learning Data and Margin ');
%axis([-2 2 -2 2]);
% clear global svModel;

