function multicarpette(method)
close all
global svModel;

%--------------------------------------------------
n='carpette';
nbapp = 500;
nbtest = 100;
[xapp,yapp,xtest,ytest]=dataset(n,nbapp,nbtest);
nbclass = 4;
[xtesta1,xtesta2]=meshgrid([-1:0.05:1],[-1:0.05:1]);
[na,nb]=size(xtesta1);
xtest1=reshape(xtesta1,1,na*nb);
xtest2=reshape(xtesta2,1,na*nb);
xtest=[xtest1;xtest2];
donnees = data(xapp,yapp,xtest);
%-----------------------------------------------------
%   Learning and Learning Parameters
C = inf;
p = 6;
ker = 'rbf';
noyau = kernel(ker,p);
tolerance = 1e-5;
pas = 50;
multiclass = '1vsall';
parametres = param(C,pas,multiclass,method,tolerance);

%---------------------One Against All algorithms----------------
trainSVM(donnees,noyau,parametres);

[ypred]=testSVM;
ypredmat=reshape(ypred(:,1),na,nb);
contourf(xtesta1,xtesta2,ypredmat,30);shading flat
style=['x+*v'];
color=['ybcg'];
hold on
[cs,h]=contour(xtesta1,xtesta2,ypredmat,[1 2 3 4],'k');
clabel(cs,h);
for i=1:nbclass
    h1=plot(xapp(1,yapp==i),xapp(2,yapp==i),[style(i) color(i)]); 
    set(h1,'LineWidth',2);
end; 
axis( [ -1 1 -1 1]);
colormap(gray);
title('Carpette Problem with 1 vs All');
hold off

%---------------------One Against One algorithms----------------
% %-----------------------------------------------------
% %   Learning and Learning Parameters
p = 5;
ker = 'rbf';
noyau = kernel(ker,p);
multiclass = '1vs1';
parametres = param(C,pas,multiclass,method,tolerance);

trainSVM(donnees,noyau,parametres);
figure;
[ypred]=testSVM;
ypredmat=reshape(ypred(:,1),na,nb);
contourf(xtesta1,xtesta2,ypredmat,30);shading flat
hold on
[cs,h]=contour(xtesta1,xtesta2,ypredmat,[1 2 3 4],'k');
clabel(cs,h);
for i=1:nbclass
    h1=plot(xapp(1,yapp==i),xapp(2,yapp==i),[style(i) color(i)]); 
    set(h1,'LineWidth',2);
end; 

colormap(gray);
title('Carpette Problem with 1 vs 1');
hold off



