
close all
global svModel;

%-------------Data Set-------------------------------------
nbapp=1000;
nbtest=5000;
sigma=2;
[vector_training_set,label_training_set,vector_test_set,label_test_set]=dataset('multiclassCheckers',nbapp,nbtest,sigma);
rn = randperm(length(label_training_set));
donnees = data(vector_training_set(:,rn),label_training_set(rn),vector_test_set,label_test_set);
%-----------------------------------------------------
%   Learning and Learning Parameters
meth = 'chol';
multiclass = '1vsall';
C = 5000000;
tolerance = .00001;
noyau = kernel('rbf',2);
pas = 50;
parametres = param(C,pas,multiclass,meth,tolerance);
tic;
chunkingSVM(donnees, noyau, parametres,100);
toc
%--------------Testing Generalization performance ---------------

svModel.data.testvec = donnees.testvec;
prediction = testSVM;
perf1 = length(find(sign(donnees.testlab)==sign(prediction(:,1))))/length(prediction(:,1));
perf2 = length(find(donnees.testlab==prediction(:,1)))/length(prediction(:,1));
fprintf(1,'performance en test: %2.2f \n',100*perf1);
fprintf(1,'performance en test: %2.2f \n',100*perf2);


[xtesta1,xtesta2]=meshgrid([-4:0.1:4],[-4:0.1:4]);
[na,nb]=size(xtesta1);
xtest1=reshape(xtesta1,1,na*nb);
xtest2=reshape(xtesta2,1,na*nb);
xtest=[xtest1;xtest2]';
svModel.data.testvec = xtest';
[ypred] = testSVM;
ypredmat=reshape(ypred(:,1),na,nb);
%----------------------Plotting---------------------------------

ind1=find(ypred>0);
indm1=find(ypred<0);

contourf(xtesta1,xtesta2,ypredmat,50);shading flat;
hold on
% [cs,h]=contour(xtesta1,xtesta2,ypredmat,[-1 0 1],'k');
[cs,h]=contour(xtesta1,xtesta2,ypredmat,[1 2 3 4],'k');
clabel(cs,h);
%h1=plot(vector_training_set(1,label_training_set==1),vector_training_set(2,label_training_set==1),'+k'); 
%set(h1,'LineWidth',2);

%h2=plot(vector_training_set(1,label_training_set==-1),vector_training_set(2,label_training_set==-1),'xk'); 
%set(h2,'LineWidth',2);
for i = 1:svModel.model.iclass-1
    h3=plot(svModel.data.trainvec(1,svModel.model.indices{i}),svModel.data.trainvec(2,svModel.model.indices{i}),'ok'); 
    set(h3,'LineWidth',2);
end


xlabel('x1');ylabel('x2');
title('Learning Data and Margin ');
axis([-2 2 -2 2]);
clear global svModel;
