function d = kernel(type,param);

switch type
    case 'rbf'
        if length(param)<1
            d.name = 'rbf';
            d.sigma = 1;
        else
            d.name = 'rbf';
            d.sigma = param(1);
        end           
    case 'poly'
        if length(param)<1
            d.name = 'poly';
            d.degree=3;
            d.scale=1;
            d.offset = 1;
        elseif length(param)<2
            d.name = 'poly';
            d.degree = param(1);
            d.scale=1;
            d.offset = 1;
        elseif length(param)<3
            d.name = 'poly';
            d.degree = param(1);
            d.scale=param(2);
            d.offset = 1;
        else
            d.name = 'poly';
            d.degree = param(1);
            d.scale=param(2);
            d.offset =param(3);
        end           
    case 'polynorm'
        if length(param)<1
            d.name = 'polynorm';
            d.degree=3;
            d.scale=1;
        elseif length(param)<2
            d.name = 'polynorm';
            d.degree = param(1);
            d.scale=1;
        else
            d.name = 'polynorm';
            d.degree = param(1);
            d.scale=param(2);
        end          
     case 'epanech'
        if length(param)<1
            d.name = 'epanech';
            d.sigma = 1;
        else
            d.name = 'epanech';
            d.sigma = param(1);
        end           
     case 'gauss'
        if length(param)<1
            d.name = 'gauss';
            d.sigma = 1;
        else
            d.name = 'gauss';
            d.sigma = param(1);
        end              
    case 'custom'
        d.name = 'custom';
        d.K = param;
    case 'tppk'
        d.name = 'tppk';
        d.K = param;
    otherwise
        error('unknown kernel');
end