function f = kernelPolVO(d,x1,x2,x3,x4)


switch d.name
    case 'rbf'
        if nargin==5
            dot_a = sum(x1.*x1,1);
            dot_b = sum(x2.*x2,1);
            unitvec = ones(size(x1,2),1);
            f = x1' * x2;
            for i=1:size(x2,2)
                f(:,i) = exp(d.sigma * (2 * f(:,i) - dot_a' - dot_b(i) * unitvec));
            end
            dot_a = sum(x3.*x3,1);
            dot_b = sum(x4.*x4,1);
            unitvec = ones(size(x3,2),1);
            f1 = x3' * x4;
            for i=1:size(x4,2)
                f(:,i) = f(:,i).*exp(d.sigma * (2 * f1(:,i) - dot_a' - dot_b(i) * unitvec));
            end
        else
            error('wrong number of input arguments');
        end
    case 'gauss'
        if nargin==5
            dot_a = sum(x1.*x1,1);
            dot_b = sum(x2.*x2,1);
            unitvec = ones(size(x1,2),1);
            f = x1' * x2;
            for i=1:size(x2,2)
                f(:,i) = (1/sqrt(2*pi*d.sigma))*exp((2 * f(:,i) - dot_a' - dot_b(i) * unitvec)./(2*d.sigma));
            end
            dot_a = sum(x3.*x3,1);
            dot_b = sum(x4.*x4,1);
            unitvec = ones(size(x3,2),1);
            f1 = x3' * x4;
            for i=1:size(x2,2)
                f(:,i) = f(:,i).*(1/sqrt(2*pi*d.sigma))*exp((2 * f1(:,i) - dot_a' - dot_b(i) * unitvec)./(2*d.sigma));
            end
        else
            error('wrong number of input arguments');
        end                 
    case 'poly'
        if nargin==5
            f = (d.scale * x1' * x2 + 1).^d.degree;
            f = f.*(d.scale * x3' * x4 + 1).^d.degree;
        else
            error('wrong number of input arguments');
        end    
    case 'epanech'
        if nargin==5
            dot_a = sum(x1.*x1,1);
            dot_b = sum(x2.*x2,1);
            unitvec = ones(size(x1,2),1);
            f = x1' * x2;
            for i=1:size(x2,2)
                f(:,i) = max(1+(d.sigma * (2 * f(:,i) - dot_a' - dot_b(i) * unitvec)),0);
            end
            dot_a = sum(x3.*x3,1);
            dot_b = sum(x4.*x4,1);
            unitvec = ones(size(x3,2),1);
            f1 = x3' * x4;
            for i=1:size(x4,2)
                f(:,i) = f(:,i).*(max(1+(d.sigma * (2 * f1(:,i) - dot_a' - dot_b(i) * unitvec)),0));
            end
        else
            error('wrong number of input arguments');
        end                   
end
