function relaxConstraintInvariant

global svModel;
global temporarelyDataNeeded;

nu = zeros(temporarelyDataNeeded.n,1);
temporarelyDataNeeded.xt = zeros(temporarelyDataNeeded.n,1);
temporarelyDataNeeded.xt(temporarelyDataNeeded.bounded) = svModel.param.C(temporarelyDataNeeded.bounded);
temporarelyDataNeeded.xt(temporarelyDataNeeded.active) = svModel.model.alpha{svModel.model.iclass};

% Are the points well classified?
%===================================================================
fx=kernelPol(svModel.kernel,svModel.data.trainvec(:,temporarelyDataNeeded.indpoints), ...
      svModel.data.trainvec(:,[temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]),...
      svModel.data.trainlab(temporarelyDataNeeded.indpoints),...
      svModel.data.trainlab([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]));
if length(svModel.param.span)>0
nu(temporarelyDataNeeded.indpoints) = fx*temporarelyDataNeeded.xt([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]) -...
      ones(length(temporarelyDataNeeded.indpoints),1)+ ...
      (svModel.data.trainlab([temporarelyDataNeeded.indpoints])*ones(1,length(temporarelyDataNeeded.indpoints)))*svModel.model.span(temporarelyDataNeeded.indpoints,:)*svModel.model.mu{svModel.model.iclass};      
else
nu(temporarelyDataNeeded.indpoints) = fx*temporarelyDataNeeded.xt([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]) -...
      ones(length(temporarelyDataNeeded.indpoints),1)+ ...
      svModel.data.trainlab([temporarelyDataNeeded.indpoints])*svModel.model.mu{svModel.model.iclass};     
end
    
      
indsat = temporarelyDataNeeded.n_bounded+1:length(temporarelyDataNeeded.indpoints);
[mm mpos]=min(nu(temporarelyDataNeeded.indpoints(indsat)));
[mmS mposS]=min(-nu(temporarelyDataNeeded.bounded));                                    

% in case not
%===================================================================

if (~isempty(mm) & (mm < -svModel.param.gap))  | (~isempty(mmS) & (mmS <  -svModel.param.gap)) % make another point become active
      if isempty(temporarelyDataNeeded.bounded) | (mm < mmS)           % put a point from inactive set to active set
            % check its transformations
            virtual_vector = [];
            virtual_vector = transformer(svModel.data.trainvec(:,temporarelyDataNeeded.indpoints(indsat(mpos))),svModel.param.transformations);
            nvirtual = size(virtual_vector,2);
            nu = zeros(temporarelyDataNeeded.n+nvirtual,1);
            fx= kernelPol(svModel.kernel,[svModel.data.trainvec(:,temporarelyDataNeeded.indpoints(indsat(mpos))),virtual_vector], ...
                  svModel.data.trainvec(:,[temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]),...
                  [svModel.data.trainlab(temporarelyDataNeeded.indpoints(indsat(mpos)))*ones(nvirtual+1,1)],...
                  svModel.data.trainlab([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]));
            nu([temporarelyDataNeeded.indpoints(indsat(mpos));[temporarelyDataNeeded.n+1:temporarelyDataNeeded.n+nvirtual]']) = fx*temporarelyDataNeeded.xt([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]) -...
                  ones(1+nvirtual,1)+ ...
                  [svModel.data.trainlab(temporarelyDataNeeded.indpoints(indsat(mpos)))*ones(nvirtual+1,1)]...
                  *svModel.model.mu{svModel.model.iclass};        
            
            temp = [temporarelyDataNeeded.indpoints(indsat(mpos));[temporarelyDataNeeded.n+1:temporarelyDataNeeded.n+nvirtual]'];
            [mm mpos]=min(nu(temp));
            if mpos>1 % it is a new point
                  % add it to the training set
                  svModel.data.trainvec(:,temporarelyDataNeeded.n+1) = virtual_vector(:,mpos-1);
                  svModel.data.trainlab = [svModel.data.trainlab;svModel.data.trainlab(temp(1))];
                  temporarelyDataNeeded.active = [temporarelyDataNeeded.active; temporarelyDataNeeded.n+1];
                  temporarelyDataNeeded.xt = [temporarelyDataNeeded.xt;0];
                  temporarelyDataNeeded.new_active = temporarelyDataNeeded.n+1;
                  svModel.param.C = [svModel.param.C;svModel.param.C(temp(1))];
            else
                  temporarelyDataNeeded.active = sort([temporarelyDataNeeded.active ; temp(1)]);  
                  temporarelyDataNeeded.new_active = temp(1);
                  temporarelyDataNeeded.inactive(find(temporarelyDataNeeded.inactive==temp(1))) = [];
            end 
            temporarelyDataNeeded.x = temporarelyDataNeeded.xt(temporarelyDataNeeded.active);
      else                                      % put a point from bounded set to active set
            % check its transformations
            virtual_vector = [];
            virtual_vector = transformer(svModel.data.trainvec(:,temporarelyDataNeeded.indpoints(indsat(mpos))),svModel.param.transformations);
            nvirtual = size(virtual_vector,2);
            nu = zeros(temporarelyDataNeeded.n+nvirtual,1);
            fx= kernelPol(svModel.kernel,[svModel.data.trainvec(:,temporarelyDataNeeded.bounded(mposS)),virtual_vector], ...
                  svModel.data.trainvec(:,[temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]),...
                  [svModel.data.trainlab(temporarelyDataNeeded.bounded(mposS))*ones(nvirtual+1,1)],...
                  svModel.data.trainlab([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]));
            nu([temporarelyDataNeeded.bounded(mposS);[temporarelyDataNeeded.n+1:temporarelyDataNeeded.n+nvirtual]']) = fx*temporarelyDataNeeded.xt([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]) -...
                  ones(1+nvirtual,1)+ ...
                  [svModel.data.trainlab(temporarelyDataNeeded.bounded(mposS))*ones(nvirtual+1,1)]...
                  *svModel.model.mu{svModel.model.iclass};        
            
            [mmS mpos]=min(-nu([temporarelyDataNeeded.bounded(mposS);[temporarelyDataNeeded.n+1:temporarelyDataNeeded.n+nvirtual]']));
            
            if mpos>1 % it is a new point
                  % add it to the training set
                  svModel.data.trainvec(:,temporarelyDataNeeded.n+1) = virtual_vector(:,mpos-1);
                  svModel.data.trainlab = [svModel.data.trainlab;svModel.data.trainlab(temporarelyDataNeeded.bounded(mposS))];
                  temporarelyDataNeeded.active = [temporarelyDataNeeded.active; temporarelyDataNeeded.n+1];
                  temporarelyDataNeeded.xt = [temporarelyDataNeeded.xt;0];
                  temporarelyDataNeeded.new_active = temporarelyDataNeeded.n+1;
                  svModel.param.C = [svModel.param.C;svModel.param.C(temporarelyDataNeeded.bounded(mposS))];
            else
                  temporarelyDataNeeded.active = sort([temporarelyDataNeeded.active ; temporarelyDataNeeded.bounded(mposS)]);  
                  temporarelyDataNeeded.new_active = temporarelyDataNeeded.bounded(mposS);
                  temporarelyDataNeeded.bounded(mposS) = [];
            end 
            temporarelyDataNeeded.x = temporarelyDataNeeded.xt(temporarelyDataNeeded.active);
      end
      test=1;                     
elseif temporarelyDataNeeded.nb_test==0 % no candidate point in the tested set
      temporarelyDataNeeded.nb_test = temporarelyDataNeeded.indpoints(end);
      temporarelyDataNeeded.new_active = 0;
else
      temporarelyDataNeeded.new_active = 0;
end
temporarelyDataNeeded.n = length(svModel.data.trainlab);
if temporarelyDataNeeded.new_active > length(temporarelyDataNeeded.relative)
    temporarelyDataNeeded.relative(temporarelyDataNeeded.new_active) = 0;
end
