function relaxConstraintLasvm

global svModel;
global temporarelyDataNeeded;

n = length(svModel.data.trainlab);
nu = zeros(n,1);
temporarelyDataNeeded.xt = zeros(n,1);
temporarelyDataNeeded.xt(temporarelyDataNeeded.bounded) = svModel.param.C(temporarelyDataNeeded.bounded);
temporarelyDataNeeded.xt(temporarelyDataNeeded.active) = svModel.model.alpha{svModel.model.iclass};

% Are the points well classified?
%===================================================================
fx=kernelPol(svModel.kernel,svModel.data.trainvec(:,temporarelyDataNeeded.indpoints), ...
      svModel.data.trainvec(:,[temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]),...
      ones(size(svModel.data.trainlab(temporarelyDataNeeded.indpoints))),...
      svModel.data.trainlab([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]));
if length(svModel.param.span)>0
    nu(temporarelyDataNeeded.indpoints) = fx*temporarelyDataNeeded.xt([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]) -...
      ones(length(temporarelyDataNeeded.indpoints),1)+ ...
      (svModel.data.trainlab([temporarelyDataNeeded.indpoints])*ones(1,length(temporarelyDataNeeded.indpoints)))*svModel.model.span(temporarelyDataNeeded.indpoints,:)*svModel.model.mu{svModel.model.iclass};      
elseif length(svModel.param.weighs)>0
    nu(temporarelyDataNeeded.indpoints) = (fx*temporarelyDataNeeded.xt([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]) -...
      ones(length(temporarelyDataNeeded.indpoints),1)+ ... 
      svModel.data.trainlab([temporarelyDataNeeded.indpoints])*svModel.model.mu{svModel.model.iclass})./...
      svModel.param.weighs(temporarelyDataNeeded.indpoints);   
else
    nu(temporarelyDataNeeded.indpoints) = fx*temporarelyDataNeeded.xt([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]) -...
      ones(length(temporarelyDataNeeded.indpoints),1)+ svModel.model.mu{svModel.model.iclass};
      %svModel.data.trainlab([temporarelyDataNeeded.indpoints])*svModel.model.mu{svModel.model.iclass};   
        %svModel.param.tube(temporarelyDataNeeded.indpoints)'+ ... 
end
    
      
indsat = temporarelyDataNeeded.n_bounded+1:length(temporarelyDataNeeded.indpoints);
[mm mpos]=min(abs(nu(temporarelyDataNeeded.indpoints(indsat))));
[mmS mposS]=min(-nu(temporarelyDataNeeded.bounded));  

% in case not
%===================================================================

if (~isempty(mm)) & (mm < 1+abs(svModel.model.mu{svModel.model.iclass}))  % | (~isempty(mmS) & (mmS <  -svModel.param.gap)) % make another point become active
      
            temporarelyDataNeeded.active = sort([temporarelyDataNeeded.active ; temporarelyDataNeeded.indpoints(indsat(mpos))]);  
            temporarelyDataNeeded.x = temporarelyDataNeeded.xt(temporarelyDataNeeded.active);
            temporarelyDataNeeded.new_active = temporarelyDataNeeded.indpoints(indsat(mpos));
            temporarelyDataNeeded.inactive(temporarelyDataNeeded.j*svModel.param.step+mpos) = [];
%       else                                      % put a point from bounded set to active set
%             temporarelyDataNeeded.active = sort([temporarelyDataNeeded.active ; temporarelyDataNeeded.bounded(mposS)]); 
%             temporarelyDataNeeded.x = temporarelyDataNeeded.xt(temporarelyDataNeeded.active);                           
%             temporarelyDataNeeded.new_active = temporarelyDataNeeded.bounded(mposS);
%             temporarelyDataNeeded.bounded(mposS)=[];
%       end
      test=1;   
elseif temporarelyDataNeeded.nb_test==0 % no candidate point in the tested set
      temporarelyDataNeeded.nb_test = temporarelyDataNeeded.indpoints(end);
      temporarelyDataNeeded.new_active = 0;
else
      temporarelyDataNeeded.new_active = 0;
end

