function relaxConstraint

global svModel;
global temporarelyDataNeeded;

n = size(svModel.data.trainlab,2);
nu = zeros(n,1);
temporarelyDataNeeded.xt = zeros(n,1);
temporarelyDataNeeded.xt(temporarelyDataNeeded.bounded) = svModel.param.C(temporarelyDataNeeded.bounded);
temporarelyDataNeeded.xt(temporarelyDataNeeded.active) = svModel.model.alpha{svModel.model.iclass};

% Are the points well classified?
%===================================================================

fx=kernelPolVO(svModel.kernel,svModel.data.trainvec(:,temporarelyDataNeeded.indpoints), ...
      svModel.data.trainvec(:,[temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]),...
      svModel.data.trainlab(:,temporarelyDataNeeded.indpoints),...
      svModel.data.trainlab(:,[temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]));
  
 nu(temporarelyDataNeeded.indpoints) = fx*temporarelyDataNeeded.xt([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]) -...
      ones(length(temporarelyDataNeeded.indpoints),1)+ ... 
      svModel.data.trainlab([temporarelyDataNeeded.indpoints])*svModel.model.mu{svModel.model.iclass};   
 

indsat = temporarelyDataNeeded.n_bounded+1:length(temporarelyDataNeeded.indpoints);
[mm mpos]=min(nu(temporarelyDataNeeded.indpoints(indsat)));
[mmS mposS]=min(-nu(temporarelyDataNeeded.bounded));

% in case not
%===================================================================

if (~isempty(mm) & (mm < -svModel.param.gap))  | (~isempty(mmS) & (mmS <  -svModel.param.gap)) % make another point become active
    if isempty(temporarelyDataNeeded.bounded) | (mm < mmS)           % put a point from inactive set to active set
        temporarelyDataNeeded.active = sort([temporarelyDataNeeded.active ; temporarelyDataNeeded.indpoints(indsat(mpos))]);  
        temporarelyDataNeeded.x = temporarelyDataNeeded.xt(temporarelyDataNeeded.active);
        temporarelyDataNeeded.new_active = temporarelyDataNeeded.indpoints(indsat(mpos));
        temporarelyDataNeeded.inactive(temporarelyDataNeeded.j*svModel.param.step+mpos) = [];
    else                                      % put a point from bounded set to active set
        temporarelyDataNeeded.active = sort([temporarelyDataNeeded.active ; temporarelyDataNeeded.bounded(mposS)]); 
        temporarelyDataNeeded.x = temporarelyDataNeeded.xt(temporarelyDataNeeded.active);                           
        temporarelyDataNeeded.new_active = temporarelyDataNeeded.bounded(mposS);
        temporarelyDataNeeded.bounded(mposS)=[];
    end
    test=1;                     
elseif temporarelyDataNeeded.nb_test==0 % no candidate point in the tested set
    temporarelyDataNeeded.nb_test = temporarelyDataNeeded.indpoints(end);
    temporarelyDataNeeded.new_active = 0;
else
    temporarelyDataNeeded.new_active = 0;
end

