function  sherman_morrison(ind,u)

% sherman_morrison
% 
% This function performs an update of the inversed kernel matrix thanks to
% Sherman-Morrison formulae : 
%
% inv(A1+u*v') = inv(A1)- (inv(A1)*u*v'*inv(A1))/(1+v'*inv(A1)*u)

% Author(s) : Gaelle Loosli
% Creation : Octobre 2003
% Update : march 2004

global svModel
global temporarelyDataNeeded

n = length(u);
u2 = [zeros(1,ind-1) 1 zeros(1,n-ind)]';
v1 = [zeros(1,ind-1) 1 zeros(1,n-ind)];
a=1;
if svModel.model.G1{svModel.model.iclass}(ind,ind)==0
    svModel.model.G1{svModel.model.iclass}(ind,ind)=1;
    u(ind) = (u(ind)-1)/2; 
else
    u(ind) = u(ind)/2; 
end
b = v1*svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)*u;
if (b==-1)
    a=1.0001;
end
B = (svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H) -...
 ((svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)*u)...
 *(v1*svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)))/(a+b));
c = u'*B*u2;
if (c==-1)
    a=1.0001;
end
svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H) = (B - ((B*u2)*(u'*B))/(a+c));
